"use strict";

exports.__esModule = true;
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _KeyedApi = require("./KeyedApi");

var _KeyedApi2 = _interopRequireDefault(_KeyedApi);

var _KeyedShadowImpl = require("./KeyedShadowImpl");

var _KeyedShadowImpl2 = _interopRequireDefault(_KeyedShadowImpl);

var _Property2 = require("./Property");

var _Property3 = _interopRequireDefault(_Property2);

var _SimpleShadow = require("./SimpleShadow");

var _SimpleShadow2 = _interopRequireDefault(_SimpleShadow);

var _createPropertyClass = require("./createPropertyClass");

var _createPropertyClass2 = _interopRequireDefault(_createPropertyClass);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
	A generic object property type that supports keyed child properties. The default implementation class is
	KeyedShadowImpl. The default shadow class is SimpleShadow.

	Transition note: Slowly migrating API away from accessing property related entities using
		Object.defineProperty() or get xyz() and using methods instead to reduce shadowing overhead.
*/

var ObjectProperty = function (_Property) {
	_inherits(ObjectProperty, _Property);

	function ObjectProperty() {
		var initialState = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
		var autoShadow = arguments[1];
		var readonly = arguments[2];

		_classCallCheck(this, ObjectProperty);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectProperty).call(this, initialState, autoShadow, readonly));

		_this._keyed = new _KeyedApi2.default(_this);

		_this.setImplementationClass(_KeyedShadowImpl2.default);
		_this.setShadowClass(_SimpleShadow2.default);
		return _this;
	}

	/*
 	Factory function for creating an ObjectProperty subclass suitable for using with new.
 		Parameters (all are optional):
 		shadowType: one of a pojo or class. This parameter defines the new property
 			shadow. If pojo specified, each property and function is mapped onto a SimpleShadow subclass.
 		stateSpec: a StateType instance defining the Property
 		specCallback: a callback function that will be passed the StateType spec for additional
 			customization, such as setting autoshadow, initial state, or readonly.
 */


	_createClass(ObjectProperty, null, [{
		key: "createClass",
		value: function createClass() {
			var shadowType = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
			var stateSpec = arguments[1];
			var specCallback = arguments[2];

			return (0, _createPropertyClass2.default)(shadowType, stateSpec, specCallback, ObjectProperty);
		}
	}, {
		key: "createSimpleClass",
		value: function createSimpleClass(specCallback) {
			return (0, _createPropertyClass2.default)({}, null, specCallback, ObjectProperty);
		}

		/*
  	Creates a StateType defining an ObjectProperty.
  		Parameters:
  		defn: a pojo where each property is a StateType definition and defines the properties
  			for the new type.
  */

	}, {
		key: "objectType",
		value: function objectType() {
			var defn = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _require = require("./StateTypes");

			var StateType = _require.StateType;

			var type = new StateType(ObjectProperty);
			var propType;

			for (var key in defn) {
				type.addProperty(key, defn[key]);
			}

			return type;
		}

		/*
  	Used by StateTypes to determine if StateTypes.properties(propTypes) may be invoked.
  */

	}, {
		key: "supportsKeyedChildProperties",
		value: function supportsKeyedChildProperties() {
			return true;
		}
	}]);

	return ObjectProperty;
}(_Property3.default);

exports.default = ObjectProperty;