"use strict";

exports.__esModule = true;
exports.default = exports.TransientShadow = exports.TransientLock = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _akutils = require("akutils");

var _createShadowClass = require("./createShadowClass");

var _createShadowClass2 = _interopRequireDefault(_createShadowClass);

var _ObjectProperty2 = require("./ObjectProperty");

var _ObjectProperty3 = _interopRequireDefault(_ObjectProperty2);

var _PrimitiveProperty = require("./PrimitiveProperty");

var _PrimitiveProperty2 = _interopRequireDefault(_PrimitiveProperty);

var _SimpleShadow2 = require("./SimpleShadow");

var _SimpleShadow3 = _interopRequireDefault(_SimpleShadow2);

var _debug = require("./debug");

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var debug = (0, _debug2.default)(_debug.TransientKey);

var _data = "data";
var _desc = Symbol('desc');
var _id = "id";
var _lockId = Symbol('lockId');
var _locks = Symbol('locks');
var _subscribers = Symbol('subscribers');
var _trans = Symbol('trans');
var _transId = Symbol('id');
var PrimaryLockName = "__primary__";

var nextLockId = 1;

var TransientLock = exports.TransientLock = function () {
	function TransientLock(id, desc, trans) {
		_classCallCheck(this, TransientLock);

		this[_lockId] = id;
		this[_desc] = desc;
		this[_trans] = trans;
	}

	_createClass(TransientLock, [{
		key: "desc",
		value: function desc() {
			return this[_desc];
		}
	}, {
		key: "id",
		value: function id() {
			return this[_lockId];
		}
	}, {
		key: "is",
		value: function is(desc) {
			return this[_desc] === desc;
		}
	}, {
		key: "release",
		value: function release() {
			this[_trans]._removeLock(this);
		}
	}, {
		key: "trans",
		value: function trans() {
			return this[_trans];
		}
	}]);

	return TransientLock;
}();

var TransientShadow = exports.TransientShadow = function (_SimpleShadow) {
	_inherits(TransientShadow, _SimpleShadow);

	function TransientShadow() {
		_classCallCheck(this, TransientShadow);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(TransientShadow).apply(this, arguments));
	}

	_createClass(TransientShadow, [{
		key: "delete",
		value: function _delete() {
			var transRoot = this.$$().parent._();

			transRoot.delete(this.id);
		}
	}, {
		key: "isLocked",
		value: function isLocked() {
			return this.$$().isLocked();
		}
	}, {
		key: "lock",
		value: function lock(desc) {
			return this.$$().lock(desc);
		}

		/*
  	Releases the primary lock. Convenience method so the lock does not have to be independently
  	managed when a transient object has a single consumer, such as react component.
  */

	}, {
		key: "release",
		value: function release() {
			this.$$().release();
		}
	}, {
		key: "primaryLock",
		get: function get() {
			return this.$$().primaryLock();
		}
	}]);

	return TransientShadow;
}(_SimpleShadow3.default);

/*

*/


var TransientProperty = function (_ObjectProperty) {
	_inherits(TransientProperty, _ObjectProperty);

	function TransientProperty(id, property) {
		_classCallCheck(this, TransientProperty);

		var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(TransientProperty).call(this, {}, false, true));

		_this2._keyed.addProperty(_data, property);
		_this2._keyed.addProperty(_id, new _PrimitiveProperty2.default(id, false, true));

		_this2.setShadowClass(TransientShadow);
		_this2[_transId] = id;
		_this2[_locks] = [];

		// create the primary lock (ensures transient is locked before first sweep)
		_this2.lock(PrimaryLockName);

		debug("TransientProperty created: id=" + id);
		return _this2;
	}

	_createClass(TransientProperty, [{
		key: "propertyWillUnshadow",
		value: function propertyWillUnshadow() {
			delete this[_locks];

			debug("propertyWillUnshadow(): id=" + this[_transId]);
		}
	}, {
		key: "isLocked",
		value: function isLocked() {
			return this[_locks] && this[_locks].length > 0;
		}
	}, {
		key: "lock",
		value: function lock() {
			var desc = arguments.length <= 0 || arguments[0] === undefined ? "lock:" + nextLockId : arguments[0];

			return this._addLock(new TransientLock(nextLockId++, desc, this));
		}
	}, {
		key: "primaryLock",
		value: function primaryLock() {
			return this[_locks] && this[_locks].find(function (l) {
				return l.is(PrimaryLockName);
			});
		}
	}, {
		key: "release",
		value: function release() {
			var primary = this.primaryLock();

			primary && primary.release();
		}
	}, {
		key: "_removeLock",
		value: function _removeLock(lock) {
			if (!this[_locks]) {
				return;
			}

			this[_locks] = this[_locks].filter(function (l) {
				return l !== lock;
			});
			debug("_removeLock(): id=" + this[_transId] + ", locked=" + this.isLocked() + ", desc=" + lock.desc());
		}
	}, {
		key: "_addLock",
		value: function _addLock(lock) {
			var _this3 = this;

			(0, _akutils.assert)(function (a) {
				return a.is(lock.trans() === _this3, "Lock transient object mismatch");
			});

			if (!this[_locks]) {
				return null;
			}

			this[_locks].push(lock);
			debug("_addLock(): id=" + this[_transId] + ", desc=" + lock.desc());

			return lock;
		}
	}, {
		key: "id",
		get: function get() {
			return this[_transId];
		}
	}]);

	return TransientProperty;
}(_ObjectProperty3.default);

exports.default = TransientProperty;