"use strict";

exports.__esModule = true;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = createIndexedPropertyType;

var _IndexedProperty2 = require("./IndexedProperty");

var _IndexedProperty3 = _interopRequireDefault(_IndexedProperty2);

var _IndexedShadow2 = require("./IndexedShadow");

var _IndexedShadow3 = _interopRequireDefault(_IndexedShadow2);

var _StateTypes = require("./StateTypes");

var _StateTypes2 = _interopRequireDefault(_StateTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
	Creates an ArrayProperty subclass based on a custom Shadow type.
*/
function createIndexedPropertyType(shadowType, elementType, specCallback) {
	var ShadowClass;

	// get the shadow class
	if (shadowType instanceof _IndexedShadow3.default) {
		// shadow class passed into method
		ShadowClass = shadowType;
	} else {
		var CustomIndexedShadow = function (_IndexedShadow) {
			_inherits(CustomIndexedShadow, _IndexedShadow);

			function CustomIndexedShadow() {
				_classCallCheck(this, CustomIndexedShadow);

				return _possibleConstructorReturn(this, Object.getPrototypeOf(CustomIndexedShadow).apply(this, arguments));
			}

			return CustomIndexedShadow;
		}(_IndexedShadow3.default);

		var proto = CustomIndexedShadow.prototype;
		var names = Object.getOwnPropertyNames(shadowType);
		var name, desc;

		for (var i = 0, len = names.length; i < len; i++) {
			name = names[i];
			desc = Object.getOwnPropertyDescriptor(shadowType, name);

			Object.defineProperty(proto, name, desc);
		}

		ShadowClass = CustomIndexedShadow;
	}

	// create the property subclass

	var CustomIndexedProperty = function (_IndexedProperty) {
		_inherits(CustomIndexedProperty, _IndexedProperty);

		function CustomIndexedProperty() {
			_classCallCheck(this, CustomIndexedProperty);

			return _possibleConstructorReturn(this, Object.getPrototypeOf(CustomIndexedProperty).apply(this, arguments));
		}

		_createClass(CustomIndexedProperty, [{
			key: "shadowClass",
			value: function shadowClass() {
				return ShadowClass;
			}
		}]);

		return CustomIndexedProperty;
	}(_IndexedProperty3.default);

	CustomIndexedProperty.stateSpec = _StateTypes2.default.property(CustomIndexedProperty);

	if (elementType) {
		CustomIndexedProperty.stateSpec.setElementType(elementType);
	}

	if (specCallback) {
		specCallback(CustomIndexedProperty.stateSpec);
	}

	return CustomIndexedProperty;
}