"use strict";

exports.__esModule = true;
exports.TransientKey = exports.StoreKey = exports.CollectionPropertyKey = exports.CollectionAllKey = exports.AllKey = exports.warn = exports.info = exports.error = undefined;

var _akutils = require("akutils");

var debug = (0, _akutils.isNative)() ? require("react-native-debug") : require("debug");

//-----------------------------------------------------------------------------------------------------------
// Debug level functions
//-----------------------------------------------------------------------------------------------------------

var ErrorKey = 'f.lux:error';
var InfoKey = 'f.lux:info';
var WarningKey = 'f.lux:warn';

if (process.env.NODE_ENV !== 'production') {
	// comment out one or more of following line to disable error/warning reporting
	debug.enable(ErrorKey);
	debug.enable(InfoKey);
	debug.enable(WarningKey);
}

var error = exports.error = debug(ErrorKey);
var info = exports.info = debug(InfoKey);
var warn = exports.warn = debug(WarningKey);

//-----------------------------------------------------------------------------------------------------------
// Functional flags
//-----------------------------------------------------------------------------------------------------------

var AllKey = exports.AllKey = 'f.lux:*';

var CollectionAllKey = exports.CollectionAllKey = 'f.lux:collection:*';
var CollectionPropertyKey = exports.CollectionPropertyKey = 'f.lux:collection:property';

var StoreKey = exports.StoreKey = 'f.lux:store';
var TransientKey = exports.TransientKey = 'f.lux:transient';

// uncomment to turn on all postop-stores logging (or selectively using one of keys above)
//debug.enable(AllKey);

debug.enable(TransientKey);

exports.default = debug;